----------------------------------------------------------------------------------
-- ECE 3401 Spring 2025: Programming Assignment 2's Test Bench
-- University of Connecticut
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
 
entity testbench1 is
end testbench1;
 
architecture Behavior OF testbench1 IS 
 component pa2
    port(
         clk, reset : in  std_logic;
         X, Y : in  unsigned(31 downto 0);
         rdy_lcm, rdy_gcd : out std_logic;
         lcm, gcd : out unsigned(31 downto 0)
        );
    end component;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
   
   -- Inputs 
   signal x, y : unsigned(31 downto 0) := (others => '0');
   signal clk, reset : std_logic := '0';
   signal rdy_lcm, rdy_gcd : std_logic := '0';

   --signal sel_lcm, sel_gcd : unsigned(1 downto 0) := (others => '0');

   -- Outputs
   signal lcm, gcd : unsigned(31 downto 0) := (others => '0');

   -- statistics
   signal cycles : unsigned(31 downto 0) := (others => '0');
 
begin
   
    -- Instantiate the Unit Under Test (UUT)
   uut: pa2 port map (
          clk => clk,
          reset => reset,
          rdy_lcm => rdy_lcm,
          rdy_gcd => rdy_gcd,
          X => x,
          Y => y,
          lcm => lcm,
          gcd => gcd);

   -- Clock process definitions
   clk_process: process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
        cycles <= cycles + 1;
   end process;

     -- Stimulus process
   stim_proc: process
   begin	
        --Reset system state
        reset <= '1';
        --Next, we need to set the inputs x and y. For example, x = 7 and y = 5.
		--Note: to_unsigned(x, y) turns value x into y-bit unsigned vector
		x <= to_unsigned(7, 32); 
		y <= to_unsigned(5, 32);
        wait for 1 ns;
        reset <= '0';
        wait for clk_period;
        wait until rdy_lcm and rdy_gcd;
        report "@ cycle: " & integer'image(to_integer(cycles)); 
        report "LCM (7, 5): " & integer'image(to_integer(lcm));
        report "GCD (7, 5): " & integer'image(to_integer(gcd));
        wait for clk_period;

        reset <= '1';
		x <= to_unsigned(54, 32); 
		y <= to_unsigned(24, 32);
        wait for 1 ns;
        reset <= '0';
        wait until rdy_lcm and rdy_gcd;
        report "@ cycle: " & integer'image(to_integer(cycles)); 
        report "LCM (54, 24): " & integer'image(to_integer(lcm));
        report "GCD (54, 24): " & integer'image(to_integer(gcd));

        wait for clk_period;
        reset <= '1';
		x <= to_unsigned(1425, 32); 
		y <= to_unsigned(75, 32);
        wait for 1 ns;
        reset <= '0';
        wait until rdy_lcm and rdy_gcd;
        report "@ cycle: " & integer'image(to_integer(cycles)); 
        report "LCM (1425, 75): " & integer'image(to_integer(lcm));
        report "GCD (1425, 75): " & integer'image(to_integer(gcd));

        wait for clk_period;
        reset <= '1';
		x <= to_unsigned(8, 32); 
		y <= to_unsigned(12, 32);
        wait for 1 ns;
        reset <= '0';
        wait until rdy_lcm and rdy_gcd;
        report "@ cycle: " & integer'image(to_integer(cycles)); 
        report "LCM (8, 12): " & integer'image(to_integer(lcm));
        report "GCD (8, 12): " & integer'image(to_integer(gcd));

        wait;
   end process;

end Behavior;
